/*
   $Id: ParametersFreq.h 648 2011-10-31 12:59:22Z manu $
*/
/*
 * Copyright INRA/CNRS - Thomas.Faraut@toulouse.inra.fr, Emmanuel.Courcelle@toulouse.inra.fr
 * This software is a computer program whose purpose is to align nucleic sequences, or perform other utility tasks
 * This software is governed by the CeCILL-C license under French law and abiding by the rules of distribution of free software.
 * 
 * Please read the file Licence_CeCILL-C_V1-en.txt which should have been distributed with this file
 * The fact that you are presently reading this, and the aforementioned file, means that you have had
 * knowledge of the CeCILL-C license and that you accept its terms.
*/

#ifndef PARAMETERS_FREQ_H__
#define PARAMETERS_FREQ_H__

#include "Parameters.h"

/**
 * \brief this class represents the command line parameters.
*         It is a singleton, thus it may be used by any object/function through the Instance() static functions
* \par Initialization
* \code
Parameters& parameters = Parameters::Instance();
parameters.InitializeFromCommandLine(argc,argv,Usage,GLINT);
\endcode

*/
class ParametersInitializerFreq: public ParametersInitializer {
	protected:
		virtual CSimpleOpt _Init (int, char* argv[], const Command&);
		virtual void _Init2(const CSimpleOpt&, const Command&);
		virtual bool _Validation();
};
#endif
