/*
   $Id: dust.cpp 646 2011-10-28 13:30:08Z tfaraut $
*/


/* dust.c */

#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

#include "dust.h"
#include "word.h"


void dust::__init_zeros(void)
{
	int i;
	sizeof_zeros=64*sizeof(int);
	counts=(int*)malloc(sizeof_zeros);
	zeros=(int*)malloc(sizeof_zeros);
	for (i=0;i<64;i++) zeros[i]=0;
}


void dust::__wo1(int len,unsigned char* s,int ivv)
{
	const int n1=63;
	int c;
	int i, ii, j, v, t, sum;
	
	memcpy(counts,zeros,sizeof_zeros);

	i = 0;
	ii = 0;
	sum = 0;
	v = 0;
	for (j=0; j < len; j++, s++) {
		ii <<= 2;
		if ((c=WordDnaCode::code(*s))<WordDnaCode::N) {
			ii|=c;
		} else {
			i = 0;
			continue;
		}
		ii &= n1;
		i++;
		if (i >= word) {
			if ((t = counts[ii]++) > 0) {
				sum += t;
				v = 10 * sum / j;
				if (mv < v) {
					mv = v;
					iv = ivv;
					jv = j;
				}
			}
		}
	}

}

int dust::__wo(int len, unsigned char *s, int& beg, int& end)
{
	int i, l1;

	l1 = len - word + 1;
	if (l1 < 0) {
        beg = 0;
        end = len - 1;
		return 0;
	}
	mv = 0;
	iv = 0;
	jv = 0;
	for (i=0; i < l1; i++) {
		__wo1(len-i, s+i, i);
	}
    beg = iv;
    end = iv + jv;
	return mv;
}

/**
 * \brief Detecting low complexity sequences
 *        - For each window of size window[64] launch __wo (count occurences of words of size word[3])
 *     see Aleksandr Morgulis, E. Michael Gertz, Alejandro A. Schäffer, and Richa Agarwala. Journal of Computational Biology. June 2006, 13(5): 1028-1040. doi:10.1089/cmb.2006.13.1028. 
 *     for a detailed explanation of how the algorithm works.
 * "global" modified : mv, iv and jv
 */
void dust::operator()(int len,unsigned char *s)
{
	int i, j, l, from, to, a, b, v;

	from = 0;
	to = -1;
	for (i=0; i < len; i += window2) {
		from -= window2;
		to -= window2;
		
		l = (len > i+window) ? window : len-i;
        v = __wo(l, s+i, a, b);
		for (j = from; j <= to; j++) {
			s[i+j] = tolower(s[i+j]);
			//s[i+j] = 'N';
		}
		if (v > level) {
			for (j = a; j <= b && j < window2; j++) {
				s[i+j] = tolower(s[i+j]);
				//s[i+j] = 'N';
			}
			from = j;
			to = b;
		} else {
			from = 0;
			to = -1;
		}
	}
}
